#include "skein/particle.h"

#include <astro/constants.hpp>

Particle::Particle(const std::string& id, double mass)
    : _id(id), _mass(mass)
{
}

Particle::Particle(const Particle& other)
    : _id(other.getId()), _mass(other.getMass())
{
}

const std::string& Particle::getId() const
{
    return _id;
}

double Particle::getMass() const
{
    return _mass;
}

double Particle::getGravitationalParameter() const
{
    return _mass * astro::ASTRO_GRAVITATIONAL_CONSTANT;
}
